package com.dhcc.finance.main.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@ApiModel(value = "CwGlVoucherImport",description = "导入凭证参数")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwGlVoucherImport {

    @ApiModelProperty(value = "交易码", required = true, example = "")
    private String tradeCode;
    @ApiModelProperty(value = "模板类型", required = true, example = "")
    private String tempType;
    @ApiModelProperty(value = "批次号", required = true, example = "")
    private String batchNo;


}
