package com.dhcc.finance.main.model;

import java.util.Date;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
/**
 * 功能描述：新增会计科目版本实体类
 * @author dml
 * @date 2019年3月29日 下午3:11:20
 * @修改日志：
 */
@ApiModel(value = "CwBdSubjschemeAdd",description = "会计科目版本新增")
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
public class CwBdSubjschemeAdd {
	@ApiModelProperty(value = "科目版本编号", required = true, example = "")
    private String choosesubject;
	
    @ApiModelProperty(value = "科目版本编号", required = true, example = "")
    private String pkSubjscheme;

    @ApiModelProperty(value = "科目版本编码", required = true, example = "")
    private String code;

    @ApiModelProperty(value = "科目版本名称", required = false, example = "")
    private String name;

    @ApiModelProperty(value = "科目编码规则", required = false, example = "")
    private String rule;

    @ApiModelProperty(value = "启用状态", required = false, example = "")
    private String enablestate;

    @ApiModelProperty(value = "使用状态", required = false, example = "")
    private String useState;

    @ApiModelProperty(value = "录入人员", required = false, example = "")
    private String createUser;

    @ApiModelProperty(value = "录入时间", required = false, example = "")
    private Date createTime;

    @ApiModelProperty(value = "最后修改人员", required = false, example = "")
    private String updateUser;

    @ApiModelProperty(value = "最后修改时间", required = false, example = "CURRENT_TIMESTAMP")
    private Date updateTime;

    @ApiModelProperty(value = "备注", required = false, example = "")
    private String remark;
}
